#ifndef SPRINGLOBBY_GLOBALEVENTS_H_INCLUDED
#define SPRINGLOBBY_GLOBALEVENTS_H_INCLUDED

#include <wx/event.h>
class wxCommandEvent;

extern const wxEventType httpDownloadEvtComplete;
extern const wxEventType httpDownloadEvtFailed;
extern const wxEventType UnitSyncReloadRequest;
extern const wxEventType ExeDownloadEvt;

class IGlobalObjectHolder;
template <class T>
class GlobalObjectHolder;

class SL_GlobalEvtHandler : public wxEvtHandler
{
protected:
    friend class IGlobalObjectHolder;
    friend class GlobalObjectHolder<SL_GlobalEvtHandler>;
    SL_GlobalEvtHandler();

    DECLARE_EVENT_TABLE()

public:
    static SL_GlobalEvtHandler& GetSL_GlobalEvtHandler();
    void OnHttpDownLoadComplete(wxCommandEvent& event);
    void OnHttpDownLoadFailed(wxCommandEvent& event);
    void OnExeDownLoad(wxCommandEvent& event);
    void OnUnitSyncReload(wxCommandEvent& event);

};

#endif // SPRINGLOBBY_GLOBALEVENTS_H_INCLUDED
